module fixpkt_tb;
	reg reset;
	reg clk;
	
	reg in_eop;
	reg in_sop;
	
	wire in_ready;
	reg in_valid;
	reg out_ready;
	reg [9:0] in_data;	

	wire [9:0] out_data;
	wire out_eop, out_sop;
	wire out_valid;

	fixpkt fixpkt1 (.reset(reset), .clk(clk), .in_eop(in_eop),
		.in_sop(in_sop), .in_data(in_data), .in_ready(in_ready),
		.in_valid(in_valid), .out_ready(out_ready), .out_valid(out_valid),
		.out_data(out_data), .out_sop(out_sop), .out_eop(out_eop)
	);

	initial begin
		$dumpfile("fixpkt_tb.vcd");
		$dumpvars;

		clk = 0;

		forever begin
			#10 clk = !clk;
		end
	end

	initial begin
		reset = 1;
		#20 reset = 0;
	end

	initial begin out_ready = 0; #21 out_ready = 1; end
	initial begin in_valid = 0; #41; forever #20 in_valid = !in_valid; end

	initial begin
		in_data = 0;
		in_sop = 0;
		in_eop = 0;
	end

	always @(posedge clk) begin
		if (in_ready && in_valid) begin
			in_data <= in_data + 1;
			in_sop <= 0; in_eop <= 0;
			if (in_data == 0) in_sop <= 1;
			if (in_data == 5) in_eop <= 1;
			if (in_data == 6) in_sop <= 1;
			if (in_data == 10) in_eop <= 1;
		end

		if (in_data == 12) $finish;
	end

	// initial #500 $finish;

	always @(posedge clk) begin
		if (out_valid && out_ready) begin
			if (out_sop) $display("SOP");
			$display("%d", out_data);
			if (out_eop) $display("EOP");
		end
	end

endmodule
